<script setup lang="tsx">
import { reactive, ref, unref } from 'vue'
import {
  getT11ListApi,
  saveT11Api,
  delT11ListApi,
  delT11Api,
  queryT11Api,
  exportExcelApi,
  importExcelApiUrl
} from '@/api/irisquery/T11'
import { Upload } from '@/components/Upload'
import { TableData } from '@/api/role/types'
import { useTable } from '@/hooks/web/useTable'
import { useI18n } from '@/hooks/web/useI18n'
import { Table, TableColumn } from '@/components/Table'
import { ElButton, ElLink, ElLoading, ElPopconfirm, ElMessage } from 'element-plus'
import { Search } from '@/components/Search'
import { FormSchema } from '@/components/Form'
import { ContentWrap } from '@/components/ContentWrap'
import Write from './components/Write.vue'
import Detail from './components/Detail.vue'
import { Dialog } from '@/components/Dialog'

const { t } = useI18n()

const ids = ref<string[]>([])

const { tableRegister, tableState, tableMethods } = useTable({
  fetchDataApi: async () => {
    const { currentPage, pageSize } = tableState
    const res = await getT11ListApi({
      pageNum: unref(currentPage),
      pageSize: unref(pageSize),
      ...unref(searchParams)
    })
    return {
      list: res.body.list,
      total: res.body.total
    }
  },
  fetchDelApi: async () => {
    const res = await delT11ListApi(unref(ids))
    return !!res
  }
})

const { loading, dataList, total, currentPage, pageSize } = tableState
const { getList, getElTableExpose, delList, refresh } = tableMethods

const tableColumns = reactive<TableColumn[]>([
  {
    field: 'selection',
    type: 'selection'
  },
  {
    field: 'a010001',
    label: '机构ID'
  },
  {
    field: 'a010002',
    label: '内部机构号'
  },
  {
    field: 'a010003',
    label: '金融许可证号'
  },
  {
    field: 'a010004',
    label: '统一社会信用代码'
  },
  {
    field: 'a010005',
    label: '银行机构名称'
  },
  {
    field: 'a010006',
    label: '支付行号'
  },
  {
    field: 'a010007',
    label: '机构类型'
  },
  {
    field: 'a010008',
    label: '机构类别'
  },
  {
    field: 'a010009',
    label: '县域机构标识'
  },
  {
    field: 'a010010',
    label: '科技支行标识'
  },
  {
    field: 'a010011',
    label: '科技特色支行标识'
  },
  {
    field: 'a010012',
    label: '科技金融专营机构标识'
  },
  {
    field: 'a010013',
    label: '行政区划'
  },
  {
    field: 'a010014',
    label: '运营状态'
  },
  {
    field: 'a010015',
    label: '成立日期'
  },
  {
    field: 'a010016',
    label: '机构地址'
  },
  {
    field: 'a010017',
    label: '负责人姓名'
  },
  {
    field: 'a010018',
    label: '负责人工号'
  },
  {
    field: 'a010019',
    label: '负责人联系电话'
  },
  {
    field: 'a010020',
    label: '采集日期'
  },
  {
    field: 'action',
    label: t('tableDemo.action'),
    width: 160,
    slots: {
      default: (data: any) => {
        return (
          <>
            <ElLink type="primary" underline={false} onClick={() => action(data.row, 'edit')}>
              {t('tableDemo.edit')}
            </ElLink>
            <ElPopconfirm
              title={t('common.delTableMsg')}
              width={200}
              v-slots={{
                reference: () => {
                  return (
                    <>
                      <ElLink type="primary" underline={false}>
                        {t('tableDemo.del')}
                      </ElLink>
                    </>
                  )
                }
              }}
              onConfirm={() => delData(data.row)}
            ></ElPopconfirm>
            <ElLink type="primary" underline={false} onClick={() => action(data.row, 'detail')}>
              {t('tableDemo.detail')}
            </ElLink>
          </>
        )
      }
    }
  }
])

const searchSchema = reactive<FormSchema[]>([
  {
    field: 'a010001',
    label: '机构ID',
    component: 'Input'
  },
  {
    field: 'a010002',
    label: '内部机构号',
    component: 'Input'
  },
  {
    field: 'a010003',
    label: '金融许可证号',
    component: 'Input'
  },
  {
    field: 'a010004',
    label: '统一社会信用代码',
    component: 'Input'
  },
  {
    field: 'a010005',
    label: '银行机构名称',
    component: 'Input'
  },
  {
    field: 'a010006',
    label: '支付行号',
    component: 'Input'
  },
  {
    field: 'a010007',
    label: '机构类型',
    component: 'Input'
  },
  {
    field: 'a010008',
    label: '机构类别',
    component: 'Input'
  },
  {
    field: 'a010009',
    label: '县域机构标识',
    component: 'Input'
  },
  {
    field: 'a010010',
    label: '科技支行标识',
    component: 'Input'
  },
  {
    field: 'a010011',
    label: '科技特色支行标识',
    component: 'Input'
  },
  {
    field: 'a010012',
    label: '科技金融专营机构标识',
    component: 'Input'
  },
  {
    field: 'a010013',
    label: '行政区划',
    component: 'Input'
  },
  {
    field: 'a010014',
    label: '运营状态',
    component: 'Input'
  },
  {
    field: 'a010015',
    label: '成立日期',
    component: 'Input'
  },
  {
    field: 'a010016',
    label: '机构地址',
    component: 'Input'
  },
  {
    field: 'a010017',
    label: '负责人姓名',
    component: 'Input'
  },
  {
    field: 'a010018',
    label: '负责人工号',
    component: 'Input'
  },
  {
    field: 'a010019',
    label: '负责人联系电话',
    component: 'Input'
  },
  {
    field: 'a010020',
    label: '采集日期',
    component: 'Input'
  }
])

const searchParams = ref({})
const setSearchParams = (data: any) => {
  searchParams.value = data
  getList()
}

const dialogVisible = ref(false)
const dialogTitle = ref('')

const currentRow = ref()
const actionType = ref('')

const writeRef = ref<ComponentRef<typeof Write>>()

/**单行查询**/
const action = async (row: any, type: string) => {
  let detailLoading = ElLoading.service({
    background: 'rgba(0, 0, 0, 0.7)'
  })
  const res = await queryT11Api(row.id)
    .catch(() => {})
    .finally(() => {
      detailLoading.close()
    })
  detailLoading.close()
  if (res) {
    const data = res.body.result
    dialogTitle.value = t(type === 'edit' ? 'tableDemo.edit' : 'tableDemo.detail')
    actionType.value = type
    currentRow.value = data
    dialogVisible.value = true
  }
}

const AddAction = () => {
  dialogTitle.value = t('tableDemo.add')
  currentRow.value = undefined
  dialogVisible.value = true
  actionType.value = ''
}

const saveLoading = ref(false)

/** 保存 **/
const save = async () => {
  const write = unref(writeRef)
  const formData = await write?.submit()
  if (formData) {
    saveLoading.value = true
    const res = await saveT11Api(formData)
      .catch(() => {})
      .finally(() => {
        saveLoading.value = false
      })
    if (res) {
      dialogVisible.value = false
      currentPage.value = 1
      getList()
    }
  }
}

const delLoading = ref(false)

/** 批量删除  **/
const delDataBatch = async () => {
  const elTableExpose = await getElTableExpose()
  ids.value = elTableExpose?.getSelectionRows().map((v: TableData) => v.id) || []
  delLoading.value = true
  await delList(unref(ids).length).finally(() => {
    delLoading.value = false
  })
}

/** 单行删除 */
const delData = async (row: TableData) => {
  const res = await delT11Api(row.id)
  if (res) {
    const { code, errMsg } = res.head
    if (code === '0') {
      ElMessage.success('删除成功!')
      getList()
    } else {
      ElMessage.error(errMsg || '删除失败!')
    }
  }
}

const disabled = ref(true)

const onSelectionChange = (selection: TableData[]) => {
  disabled.value = selection.length === 0
}

/** 导出Excel */
const exportExcel = async () => {
  const data = { ...unref(searchParams) }
  await exportExcelApi(data)
}
</script>

<template>
  <ContentWrap>
    <Search :schema="searchSchema" @reset="setSearchParams" @search="setSearchParams" />

    <Table
      :columns="tableColumns"
      v-model:pageSize="pageSize"
      v-model:currentPage="currentPage"
      default-expand-all
      node-key="id"
      :data="dataList"
      :loading="loading"
      :pagination="{
        total
      }"
      @selection-change="onSelectionChange"
      @register="tableRegister"
      @refresh="refresh"
    >
      <template #buttons>
        <ElButton type="primary" @click="AddAction">{{ t('tableDemo.add') }}</ElButton>
        <Upload :url="importExcelApiUrl" :callback="getList">
          <ElButton type="primary">导入</ElButton>
        </Upload>
        <ElButton type="primary" @click="exportExcel()">导出</ElButton>
        <ElButton :loading="delLoading" type="primary" :disabled="disabled" @click="delDataBatch()">
          {{ t('tableDemo.del') }}
        </ElButton>
      </template>
    </Table>
  </ContentWrap>

  <Dialog v-model="dialogVisible" :title="dialogTitle">
    <Write v-if="actionType !== 'detail'" ref="writeRef" :current-row="currentRow" />
    <Detail v-if="actionType === 'detail'" :current-row="currentRow" />
    <template #footer>
      <ElButton v-if="actionType !== 'detail'" type="primary" :loading="saveLoading" @click="save">
        {{ t('dialogDemo.save') }}
      </ElButton>
      <ElButton @click="dialogVisible = false">{{ t('dialogDemo.close') }}</ElButton>
    </template>
  </Dialog>
</template>
